// -*- c++ -*-
// Generated by gtkmmproc -- DO NOT MODIFY!
#ifndef _GTKSOURCEVIEWMM_SOURCELANGUAGE_H
#define _GTKSOURCEVIEWMM_SOURCELANGUAGE_H


#include <glibmm.h>

/* sourcebuffer.hg
 * 
 * Copyright (C) 2004-2005 Jae Jang
 * Copyright (C) 2005-2006 Rob Page
 * Copyright (C) 2006 Dodji Seketeli
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/// \file
/// \brief the SourceLanguage class

#include <glibmm/object.h>
#include <gtksourceviewmm/sourcetag.h>
#include <gtksourceviewmm/sourcestylescheme.h>


#ifndef DOXYGEN_SHOULD_SKIP_THIS
typedef struct _GtkSourceLanguage GtkSourceLanguage;
typedef struct _GtkSourceLanguageClass GtkSourceLanguageClass;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */


namespace gtksourceview
{ class SourceLanguage_Class; } // namespace gtksourceview
namespace gtksourceview
{

class SourceLanguagesManager ;


/// \brief The abstraction of a language.
///
/// Languages are used in the syntax highlighting
/// workflow.

class SourceLanguage : public Glib::Object
{
  
#ifndef DOXYGEN_SHOULD_SKIP_THIS

public:
  typedef SourceLanguage CppObjectType;
  typedef SourceLanguage_Class CppClassType;
  typedef GtkSourceLanguage BaseObjectType;
  typedef GtkSourceLanguageClass BaseClassType;

private:  friend class SourceLanguage_Class;
  static CppClassType sourcelanguage_class_;

private:
  // noncopyable
  SourceLanguage(const SourceLanguage&);
  SourceLanguage& operator=(const SourceLanguage&);

protected:
  explicit SourceLanguage(const Glib::ConstructParams& construct_params);
  explicit SourceLanguage(GtkSourceLanguage* castitem);

#endif /* DOXYGEN_SHOULD_SKIP_THIS */

public:
  virtual ~SourceLanguage();

#ifndef DOXYGEN_SHOULD_SKIP_THIS
  static GType get_type()      G_GNUC_CONST;
  static GType get_base_type() G_GNUC_CONST;
#endif

  ///Provides access to the underlying C GObject.
  GtkSourceLanguage*       gobj()       { return reinterpret_cast<GtkSourceLanguage*>(gobject_); }

  ///Provides access to the underlying C GObject.
  const GtkSourceLanguage* gobj() const { return reinterpret_cast<GtkSourceLanguage*>(gobject_); }

  ///Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
  GtkSourceLanguage* gobj_copy();

private:


protected:
  SourceLanguage();

public:

  /// \brief create a language.
  ///
  /// \return the newly created language
  
  static Glib::RefPtr<SourceLanguage> create();


  /// \brief get language ID
  ///
  /// a language ID is unique among language IDs.
  /// \return the langugae ID.
  
  Glib::ustring get_id() const;

  /// \brief gets the localized name of the language.
  ///
  /// \return the localized name of the language
  
  Glib::ustring get_name() const;

  /// \brief the localized section of the language.
  ///
  /// Each language belong to a section (ex. HTML belogs to the Markup section).
  /// \return the localized section of the language.
  
  Glib::ustring get_section() const;

  /// \brief gets the list of tags associated to the given language.
  ///
  /// \return the list of tags associated to the language
  
  Glib::SListHandle<Glib::RefPtr<SourceTag> > get_tags();

  /// \brief gets the list of tags associated to the given language.
  ///
  /// \return the list of tags associated to the language
  
  Glib::SListHandle<Glib::RefPtr<const SourceTag> > get_tags() const;

  /// \brief Gets the value of the ESC character in the given language.
  ///
  /// \return the value of the ESC character in the given language.
  
  gunichar get_escape_char() const;

  /// \brief gets the list of mime types for the given language.
  ///
  /// After usage you should free each element of the list as well as the list itself.
  /// \return the list of  mime types for the given language.
  
  Glib::SListHandle<Glib::ustring> get_mime_types() const;

  /// \brief Sets a list of mime_types for the given language.
  ///
  /// \param mime_types the list of new mime types to set.
  
  void set_mime_types(const Glib::SListHandle<const Glib::ustring>& mime_types);
  
  /// \brief gets the style scheme associated to the language.
  ///
  /// \return the style scheme associated to the language
  
  Glib::RefPtr<SourceStyleScheme> get_style_scheme();

  /// \brief gets the style scheme associated to the language.
  ///
  /// \return the style scheme associated to the language
  
  Glib::RefPtr<const SourceStyleScheme> get_style_scheme() const;

  /// \brief sets the style scheme associated to the language
  ///
  /// \param scheme the new style scheme
  
  void set_style_scheme(Glib::RefPtr<SourceStyleScheme> scheme);

  /// \brief gets the style of the tag which ID is tag_id .
  ///
  /// \param tag_id the tag ID
  /// \return the style of the tag which ID is tag_id
  
  SourceTagStyle get_tag_style(const Glib::ustring& tag_id) const;

  /// \brief sets the style of the tag which ID is tag_id
  ///
  /// \param tag_id the tag ID
  /// \param style the new style.
  
  void set_tag_style(const Glib::ustring& tag_id, const SourceTagStyle& style);

  /// \brief gets the default style of the tag which ID is tag_id
  ///
  /// \param tag_id the ID of the tag to consider
  /// \return the default SourceTagStyle.
  
  SourceTagStyle get_tag_default_style(const Glib::ustring& tag_id) const;


public:

public:
  //C++ methods used to invoke GTK+ virtual functions:
#ifdef GLIBMM_VFUNCS_ENABLED
#endif //GLIBMM_VFUNCS_ENABLED

protected:
  //GTK+ Virtual Functions (override these to change behaviour):
#ifdef GLIBMM_VFUNCS_ENABLED
#endif //GLIBMM_VFUNCS_ENABLED

  //Default Signal Handlers::
#ifdef GLIBMM_DEFAULT_SIGNAL_HANDLERS_ENABLED
#endif //GLIBMM_DEFAULT_SIGNAL_HANDLERS_ENABLED


};

} /* namespace gtksourceview */


namespace Glib
{
  /** @relates gtksourceview::SourceLanguage
   * @param object The C instance
   * @param take_copy False if the result should take ownership of the C instance. True if it should take a new copy or ref.
   * @result A C++ instance that wraps this C instance.
   */
  Glib::RefPtr<gtksourceview::SourceLanguage> wrap(GtkSourceLanguage* object, bool take_copy = false);
}


#endif /* _GTKSOURCEVIEWMM_SOURCELANGUAGE_H */

